#!/usr/bin/perl

######################################
#			             #
#	     EZDB v 3.02            #
#	                             #
#			             #
#          By Stephane Barde   	     #
#        (webmaster@ezperl.com)      #
#	     January 31 2000         #
#				     #	
#     http://www.ezperl.com	     #
#				     #												 
######################################

# COPYRIGHT NOTICE:
#
# Copyright 1998-2001 Stephane Barde.  All Rights Reserved.
#
# This program is being distributed as a FREEWARE. 
#
# It may be used and modified by anyone, as long as this copyright notice and the header
# above remain intact, but any usage should be registered.  (See the
# chapter XIII- for registration information.)  By using this
# program you agree to indemnify Stephane Barde from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# Contributions are welcome and will be used exclusively to enhance
# the script (contact EZ Perl at webmaster@ezperl.com)

# I would off course appreciate to have some feedback about the
# use you are doing with this script.

# It also would be nice to make a link to the EZ Perl site:
# http://www.ezperl.com

$|=1;

require 5.004;

eval {
require "ezdb_setup.pl";
require "ezdb_lib.pl";
require "ez_$language.pl";
};

if ($@) {print $@} #{ &display_error_message(&get_msg(0).": $@"); }


# we use the EzTree Template
$html_template=$eztree_html_template;

#################################################
#		Main Script			#
#################################################

$ENV{'QUERY_STRING'}=~ s/<!--(.|\n)*-->//g;
$action=$ENV{'QUERY_STRING'};

if ($action =~ /assign=(\w+?):(\d+)/) {$table=$1;$key=$2;$assign="&assign=$table:$key"}
if ($action =~ /category=(\d+)*/) {$cat=$1}
if ($key) {$content.= qq!<font size="2" face="Verdana, Arial, Helvetica, sans-serif">Assigning item # <b>$key</b> from <b>$table</b> database</font><hr noshade>!;}

if ($action =~ /^add\&/) {&add_to_cat()}
elsif ($cat) {&display_cat($cat)}
else {&display_cat()}

&display_output;

exit(0);


#################################################
#		display_cat			#
#################################################

sub display_cat {

my ($master,@this_category,$subcategories_html,$items_html, %res, %subcategories, %items);

open(CAT,"<./my_db/categories.csv");
flock(CAT,1);
my @lines=<CAT>;
close(CAT);

my %cat_columns;
$_=shift @lines;
chomp;
my $i=0;
for (split(/\|/)) {$cat_columns{$_}=$i;$i++}

for (@lines)
{
my @temp=split(/\|/);
if ($temp[0] eq $_[0]) {@this_category=@temp}
if ($temp[1] eq $_[0]) {@{$res{$temp[2]}}=@temp}
}

open(HTML,"<$eztree_html_content");
flock(HTML,1);
@lines=<HTML>;
close(HTML);

my $html=join('',@lines);

if ($html =~ /<subcategories>((.|\n)+?)<\/subcategories>/) {$subcategories_html=$1}
if ($html =~ /<items>((.|\n)+?)<\/items>/) {$items_html=$1}

for (sort keys(%res))
{
my $html_line=$subcategories_html;
$html_line=~ s/_SUBCATEGORIES_/.\/eztree.cgi?category=${$res{$_}}[0]$assign/g;
$html_line=~ s/%(\w+)%/${$res{$_}}[$cat_columns{$1}]/g;

if ($key) {$html_line=~ s/_SELECT_/<a href="eztree.cgi?add&category=${$res{$_}}[0]$assign"><font size="2" color=red face="Verdana, Arial, Helvetica, sans-serif">select<\/font><\/a>/g;}
else {$html_line=~ s/_SELECT_//g;}

$subcategories.=$html_line;
}

unless ($key)
{

open(DB,"<./my_db/eztree.csv");
flock(DB,1);
@lines=<DB>;
close(DB);

my %tree_columns;
$_=shift @lines;
chomp;
$i=0;
for (split(/\|/)) {$tree_columns{$_}=$i;$i++}

foreach $line (@lines)
{
chomp $line;
my @temp=split /\|/, $line;
if ($temp[3] eq $_[0]) {$items{$temp[1]}=[@temp]}
}

sort values(%items);

for (keys(%items))
{
my $html_line=$items_html;
$html_line=~ s/%(\w+)%/${$items{$_}}[$tree_columns{$1}]/g;
$items.=$html_line;
}

} #end unless


$html=~ s/<subcategories>(.|\n)+?<\/subcategories>/$subcategories/g;
$html=~ s/<items>(.|\n)+?<\/items>/$items/g;
$html=~ s/%(\w+)%/$this_category[$cat_columns{$1}]/g;

# if we assign an object, we append $assign to any eztree connection string:
if ($assign) { $html=~ s/(eztree.cgi\?category=\d*)\"/$1$assign\"/g; }

$content.= $html;

if ($key) {$content.= qq~<font size="2" face="Verdana, Arial, Helvetica, sans-serif"><br><br><a href="javascript:this.window.close()">Close this window</a></font>~;}

}


#################################################
#		add_to_cat			#
#################################################

sub add_to_cat {

# First we grab the info about the additional field to take from the master DB in the tables system file

open(DB,"<$system_file_path/tables")|| &display_error_message("Cannot open $system_file_path/tables database");
flock(DB,1);
my @tables_lines=<DB>;
close(DB);

shift(@tables_lines);

foreach $line (@tables_lines)
{
chomp $line;
my @temp=split/\|/, $line;

if ($temp[1] =~ /^$table--(.+)$/) {$table_path=$1;@eztree_fields=split /--/, $temp[31]; $separator=$temp[6]; $separator=~ s/pipe/\|/ ;}
}

# Then we grab the data from the master DB

open(DB,"<$table_path")|| &display_error_message("Cannot open $system_file_path/tables database");
flock(DB,1);
my @lines=<DB>;
close(DB);

chomp $lines[0];
my @fields=split /\Q$separator/, shift(@lines);
for ($i=0;$i<@fields;$i++) {$index{"$fields[$i]"}=$i;}

foreach $line (@lines)
{
chomp $line;
my @temp=split /\Q$separator/, $line;

if ($temp[0] eq $key) { foreach $field (@eztree_fields) {push(@data,$temp[$index{"$field"}])} }
}


open(DB,">>./my_db/eztree.csv");
flock(DB,2);
print DB time."\|$key\|$table\|$cat\|".join('|',@data)."\n";
close(DB);


$content.= qq!
<font size="2" face="Verdana, Arial, Helvetica, sans-serif">
This item was assigned: $data[0]<br><br>
<a href="./eztree.cgi?$assign">Assign to another category</a><br><br>
<a href="javascript:this.window.close()">Close this window</a>
</font>
!;


}	

