#!/usr/bin/perl

######################################
#			             #
#	     EZDB v 3.02            #
#	                             #
#			             #
#          By Stephane Barde   	     #
#        (webmaster@ezperl.com)      #
#	     January 31 2000         #
#				     #	
#     http://www.ezperl.com	     #
#				     #												 
######################################

# COPYRIGHT NOTICE:
#
# Copyright 1998-2001 Stephane Barde.  All Rights Reserved.
#
# This program is being distributed as a FREEWARE. 
#
# It may be used and modified by anyone, as long as this copyright notice and the header
# above remain intact, but any usage should be registered.  (See the
# chapter XIII- for registration information.)  By using this
# program you agree to indemnify Stephane Barde from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# Contributions are welcome and will be used exclusively to enhance
# the script (contact EZ Perl at webmaster@ezperl.com)

# I would off course appreciate to have some feedback about the
# use you are doing with this script.

# It also would be nice to make a link to the EZ Perl site:
# http://www.ezperl.com

$|=1;

print "Content-type: text/html\n\n";

$system_file_path="./system_db";

print qq! 
<body bgcolor="#006699" text=white><center><h2>EZDB Setup Report</h2><br>
<table border=1  CELLPADDING=0 CELLSPACING=0>
<tr bgcolor="#003399">
<td colspan=2><b><font color=white size=+1>Legend</b></font></td>
</tr><tr>
<tr><td align=middle bgcolor="#003399" width=15>S</td><td>Search</td></tr>
<tr><td align=middle  bgcolor="#003399" width=15>A</td><td>Add</td></tr>
<tr><td align=middle  bgcolor="#003399" width=15>M</td><td>Modify</td></tr>
<tr><td align=middle  bgcolor="#003399" width=15>D</td><td>Delete</td></tr>
<tr><td align=middle bgcolor="#003399" width=15>&nbsp;</td><td>Permissions</td></tr>
<tr><td align=middle bgcolor="#BDC11E" width=15>&nbsp;</td><td>Menu</td></tr>
<tr><td align=middle bgcolor="#ff9900" width=15>&nbsp;</td><td>Interface</td></tr>
</table><br>

!;

open(DB,"<$system_file_path/tables") || print "cannot open tables";
flock(DB,1);
@tables_lines=<DB>;
close(DB);

open(DB,"<$system_file_path/table_group") || print "cannot open table_group";
flock(DB,1);
@table_group_lines=<DB>;
close(DB);

open(DB,"<$system_file_path/user_rights") || print "cannot open user_rights";
flock(DB,1);
@user_rights_lines=<DB>;
close(DB);


&show_tables;

push @def_tab, grep /\|default\|/, @table_group_lines;
push @def_tab, grep !/\|default\|/, @table_group_lines;


foreach $table (sort @tables)
{
	print qq!
	<table border=1  CELLPADDING=0 CELLSPACING=0>\n
  <tr bgcolor="#003399"><td width=250><b>\n<font color=white size=+1>\n$table</b></font></td>
	<td align=middle width=15>S</td><td align=middle  width=15>A</td><td align=middle  width=15>M</td><td align=middle  width=15>D</td><td align=middle bgcolor=\"\#BDC11E\" width=15>S</td><td align=middle bgcolor=\"\#BDC11E\" width=15>A</td><td align=middle bgcolor=\"\#BDC11E\" width=15>M</td><td align=middle bgcolor=\"\#BDC11E\" width=15>D</td><td align=middle bgcolor=\"\#ff9900\" width=15>L</td><td align=middle bgcolor=\"\#ff9900\" width=15>C</td></tr>
  </tr>
  <tr>!;
  
	for(@def_tab)
	{
	my @temp=split(/\|/);
	if ($temp[1] eq $table) 
		{
		my $rights="";
		if ($temp[3] eq "1") {$rights.="<td align=middle  width=15>x</td>"} else {$rights.="<td width=15 align=middle>-</td>"}
		if ($temp[4] eq "1") {$rights.="<td align=middle  width=15>x</td>"} else {$rights.="<td align=middle width=15>-</td>"}
		if ($temp[5] eq "1") {$rights.="<td align=middle  width=15>x</td>"} else {$rights.="<td align=middle width=15>-</td>"}
		if ($temp[6] eq "1") {$rights.="<td align=middle  width=15>x</td>"} else {$rights.="<td align=middle width=15>-</td>"}
		if ($temp[7] eq "1") {$rights.="<td align=middle  width=15><font color=\"\#ffff00\">x</font></td>"} else {$rights.="<td align=middle width=15><font color=\"\#ffff00\">-</font></td>"}
		if ($temp[8] eq "1") {$rights.="<td align=middle  width=15><font color=\"\#ffff00\">x</font></td>"} else {$rights.="<td align=middle width=15><font color=\"\#ffff00\">-</font></td>"}
		if ($temp[9] eq "1") {$rights.="<td align=middle  width=15><font color=\"\#ffff00\">x</font></td>"} else {$rights.="<td align=middle width=15><font color=\"\#ffff00\">-</font></td>"}
		if ($temp[10] eq "1") {$rights.="<td align=middle  width=15><font color=\"\#ffff00\">x</font></td>"} else {$rights.="<td align=middle width=15><font color=\"\#ffff00\">-</font></td>"}
		if ($temp[11] eq "1") {$rights.="<td align=middle  width=15><font color=\"\#ff9900\">x</font></td>"} else {$rights.="<td align=middle width=15><font color=\"\#ff9900\">-</font></td>"}
		if ($temp[12] eq "1") {$rights.="<td align=middle  width=15><font color=\"\#ff9900\">x</font></td>"} else {$rights.="<td align=middle width=15><font color=\"\#ff9900\">-</font></td>"}
				
		print qq!
		<td><b>$temp[2]</b></td>
		$rights</tr>
		!;
		
		print "<tr><td align=right valign=top><font size=-1><i>Authorized Users</i></font> </td><td colspan=10>";
		
		
		
		foreach $rights_line (@user_rights_lines)
			{
			chomp $rights_line;
			my @temp2=split /\|/, $rights_line;
			
			if (($temp2[2] eq $table)&&($temp2[3] eq $temp[2]))
			{ print "<li>$temp2[1]\n";}
		}
		
		if ($temp[2] =~ /^default$/i) {print "<li><i>N/A</i>";}
		print "</td></tr>";
		
		}
	}

#print "</tr><tr><td height=30 colspan=12 bgcolor=\"\#cecece\">&nbsp;</td></tr>";
print "</table><br>";	
}




exit(0);


#################################################
#		show_tables			#
#################################################

sub show_tables{

shift(@tables_lines);

for (@tables_lines)
{
my @temp=split(/\|/);
my ($name,$path)= split /--/, $temp[1];
push(@tables,$name);
}

}